/*
 *********************************************************************
 * Created on ${date}
 *
 * Copyright (C) 2003 Terabit Pty Ltd.  All rights reserved.
 *
 * This file may be distributed and used only under the terms of the  
 * Terabit Public License as defined by Terabit Pty Ltd of Australia   
 * and appearing in the file tlicense.txt included in the packaging of
 * this module and available at http://www.terabit.com.au/license.php.
 *
 * Contact support@terabit.com.au for any information
 *********************************************************************
 */
package au.com.terabit.jproactor;

import java.nio.channels.SelectableChannel;

/**
 * The <code>AsynchHandlerFactory</code> interface is responsible for creation of 
 * a new instance of {@link ProtocolAdaptor} class.
 * 
 * @author <a href="libman@terabit.com.au">Yevgeny Libman</a>
 * @version <code>$Revision$ $Date$</code>
 */
public interface AsynchHandlerFactory
{
    /**
     * Creates protocol instance for the given channel.
     * 
     * @param m - multiplexor that will service this protocol
     * @param sc - channel to use for this protocol 
     * @return a new <code>AsynchHandler</code> instance
     */
    public AsynchHandler createProtocol( Demultiplexor m , SelectableChannel sc ); 
}
