package au.com.terabit.testmpx;

//import java.util.concurrent.atomic.AtomicInteger;

import java.text.MessageFormat;

import EDU.oswego.cs.dl.util.concurrent.SynchronizedInt;
import au.com.terabit.jproactor.IOStatistic;


public class AutoClientProtocolFactory 
{
	public IOStatistic   m_readInfo  = new IOStatistic ();
	public IOStatistic   m_writeInfo = new IOStatistic ();
//	public AtomicInteger m_created  = new AtomicInteger (0);
//	public AtomicInteger m_finished = new AtomicInteger (0);
	public SynchronizedInt m_created  = new SynchronizedInt (0);
	public SynchronizedInt m_finished = new SynchronizedInt (0);
  
    void onProtocolStarted ()
    {
//    	m_created.incrementAndGet();
        m_created.increment();
    }
    void onProtocolFinished (IOStatistic readInfo, IOStatistic writeInfo)
    {
//    	m_finished.incrementAndGet();
        m_finished.increment();
    	m_readInfo.append(readInfo);
    	m_writeInfo.append(writeInfo);
    }
    public void printStats ()
    {
        System.out.println(
            MessageFormat.format(
                "Total Clients ({8},{9}): Reads={0}({1},{2},{3}) Writes={4}({5},{6},{7})\n",
                new Object[] {
                        new Long( m_readInfo.m_xferBytes    ),
                        new Long( m_readInfo.m_opStarted    ),
                        new Long( m_readInfo.m_opFinished   ),
                        new Long( m_readInfo.m_opCancelled  ),
                        new Long( m_writeInfo.m_xferBytes   ),
                        new Long( m_writeInfo.m_opStarted   ),
                        new Long( m_writeInfo.m_opFinished  ),
                        new Long( m_writeInfo.m_opCancelled ),
                        new Long( m_created.get() ),
                        new Long( m_finished.get() )
                   }
            ) );
    }
}
