/*
 *********************************************************************
 * Created on ${date}
 *
 * Copyright (C) 2003 Terabit Pty Ltd.  All rights reserved.
 *
 * This file may be distributed and used only under the terms of the  
 * Terabit Public License as defined by Terabit Pty Ltd of Australia   
 * and appearing in the file tlicense.txt included in the packaging of
 * this module and available at http://www.terabit.com.au/license.php.
 *
 * Contact support@terabit.com.au for any information
 *********************************************************************
 */
package au.com.terabit.testmpx;

import java.nio.channels.SelectableChannel;
import java.text.MessageFormat;
//import java.util.concurrent.atomic.*;
import EDU.oswego.cs.dl.util.concurrent.SynchronizedInt;

import au.com.terabit.jproactor.*;


/**
 * Describe your <code>EchoServerProtocolFactory</code> class here.
 * 
 * <p>Detailed description goes here.
 *
 * @author <a href="mailto:abc@xyz.org">zhenya</a>
 * @version <code>$Revision$ $Date$</code>
 */
public class EchoServerProtocolFactory implements AsynchHandlerFactory
{
    
	public IOStatistic   m_readInfo  = new IOStatistic ();
	public IOStatistic   m_writeInfo = new IOStatistic ();
//	public AtomicInteger m_created  = new AtomicInteger (0);
//	public AtomicInteger m_finished = new AtomicInteger (0);
    public SynchronizedInt m_created  = new SynchronizedInt (0);
    public SynchronizedInt m_finished = new SynchronizedInt (0);

    
    /**
     * Creates <code>EchoServer</code> protocol instance.
     * 
     * @param m - <code>Multiplexor</code> instance to use as IO processor.
     * @param channel - protocol's socket channel
     *
     * @see ProtocolFactory#createProtocol(java.nio.channels.SelectableChannel)
     */
    public AsynchHandler createProtocol( Demultiplexor m, SelectableChannel channel )
    {
        try
        {
//        	m_created.incrementAndGet();
            m_created.increment();
            return new EchoServerProtocol( m, channel, this );
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        return null;
    }

    void onProtocolFinished (IOStatistic readInfo, IOStatistic writeInfo)
    {
//    	m_finished.incrementAndGet();
        m_finished.increment();
    	m_readInfo.append(readInfo);
    	m_writeInfo.append(writeInfo);
    }
    public void printStats ()
    {
        System.out.println(
            MessageFormat.format(
                "Total Servers ({8},{9}): Reads={0}({1},{2},{3}) Writes={4}({5},{6},{7})\n",
                new Object[] {
                        new Long( m_readInfo.m_xferBytes    ),
                        new Long( m_readInfo.m_opStarted    ),
                        new Long( m_readInfo.m_opFinished   ),
                        new Long( m_readInfo.m_opCancelled  ),
                        new Long( m_writeInfo.m_xferBytes   ),
                        new Long( m_writeInfo.m_opStarted   ),
                        new Long( m_writeInfo.m_opFinished  ),
                        new Long( m_writeInfo.m_opCancelled ),
                        new Long( m_created.get() ),
                        new Long( m_finished.get() )
                   }
            ) );
    }
}
